// ignore_for_file: non_constant_identifier_names

import 'dart:math';

import 'package:general_lib/general_lib.dart';

class GenerateSecretWords {
  int min_count;
  int max_count;
  GenerateSecretWords({
    required this.min_count,
    required this.max_count,
  });

  static GenerateSecretWords minMax({
    required int minCount,
    required int maxCount,
  }) {
    return GenerateSecretWords(
      min_count: minCount,
      max_count: maxCount,
    );
  }

  static GenerateSecretWords fixed({required int totalCount}) {
    return GenerateSecretWords(
      max_count: totalCount,
      min_count: totalCount,
    );
  }

  int totalLength() {
    if (min_count == max_count) {
      return min_count;
    }
    return Random().nextInt(max_count - min_count + 1) + min_count;
  }
}

class Generate {
  Generate();

  static List<String> secretRandomWords({
    required int totalCount,
    required GenerateSecretWords generateSecretWords,
    String schema = "0123456789abcdefghijklmnopqrstuvwxyz",
  }) {
    List<String> secretWords = [];

    while (true) {
      if (secretWords.length == totalCount) {
        return secretWords;
      } else {
        String randomWord = generateUuid(generateSecretWords.totalLength(), text: schema);
        if (!secretWords.contains(randomWord)) {
          secretWords.add(randomWord);
        }
      }
    }
  }
}
