// ignore_for_file: non_constant_identifier_names, unnecessary_brace_in_string_interps

import 'dart:convert';

import 'package:general_lib/extension/extension.dart';

String generateDataSqlJson({
  required Map data,
}) {
  String script_data = "";
  data.forEach((key, value) {
    if (RegExp(r"^(@)", caseSensitive: false).hasMatch(key)) {
      return;
    }
    if (key == "id") {
      return;
    }
    String type_data = "";
    String default_data = " DEFAULT";
    if (value is num) {
      type_data = "bigint";
      // type_data += " 0";
      default_data += " 0";
    } else if (value is Map || value is List) {
      type_data = "json";
      default_data += (" '${json.encode(value)}'");
    } else if (value is String) {
      type_data = "text";
      default_data += " format(''::text)";
    } else if (value is bool) {
      type_data = "boolean";
      default_data += " false";
    } else {
      throw "not found type";
    }
    String script_data_loop = """
${key} ${type_data} ${default_data},
"""
        .trim();
    script_data += "  ${script_data_loop}";
    script_data += "\n";
  });
  return script_data.replaceAll(RegExp(r"(,|,\n)$", caseSensitive: false), "");
}

String generate_add_sql_data({
  required String tableName,
  required Map data,
}) {
  String script_data = "";
  data.forEach((key, value) {
    if (RegExp(r"^(@)", caseSensitive: false).hasMatch(key)) {
      return;
    }
    if (key == "id") {
      return;
    }
    String type_data = "";
    String default_data = "DEFAULT";
    if (value is num) {
      type_data = "bigint";
      // type_data += " 0";
      default_data += " 0";
    } else if (value is Map || value is List) {
      type_data = "json";
      default_data += (" '${json.encode(value)}'");
    } else if (value is String) {
      type_data = "text";
      default_data += " format(''::text)";
    } else if (value is bool) {
      type_data = "boolean";
      default_data += " false";
    } else {
      throw "not found type";
    }
// ${key} ${type_data} ${default_data},
    String script_data_loop = """
ALTER TABLE ${tableName} ADD COLUMN ${key} ${type_data} ${default_data};
"""
        .trim();
    script_data += "  ${script_data_loop}";
    script_data += "\n";
  });
  return script_data.replaceAll(RegExp(r"(,|,\n)$", caseSensitive: false), "");
}

// add column in
// ALTER TABLE accounts ADD COLUMN new_column text;
//
// delete column
// ALTER TABLE accounts DROP COLUMN new_column;
//
// edit
// ALTER TABLE accounts ALTER COLUMN total_price_amount TYPE boolean;
String jsonToSqlSupabase({
  required Map jsonData,
  bool isEnableRls = true,
  String? tableName,
}) {
  if (jsonData["@type"] is String == false) {
    jsonData["@type"] = "";
  }

  tableName ??= (jsonData["@type"] as String).snakeCaseClass();
  // https://supabase.com/docs/guides/database/tables?database-method=sql
  String script = """
-- 1. Create table
CREATE TABLE {table_name} ( 
  id bigint generated by default as identity primary key,

"""
      .trim();
  script += "\n";
  script += generateDataSqlJson(
    data: jsonData,
  );
  script += "\n";
  // script = script.replaceAll(RegExp(r"({table_name})", caseSensitive: false), table_name).trim();

  script += "\n";
  script += """
);
"""
      .trim();
  if (isEnableRls) {
    script += "\n";
    script += """
-- 2. Enable RLS
alter table {table_name} enable row level security;
"""
        .trim();
    script += "\n";
    script += """
-- 3. ADD Column in Tabble Exist (Optional)
"""
        .trim();
    script += "\n";
    script += generate_add_sql_data(
      data: jsonData,
      tableName: tableName,
    );
  }
  return (script
      .trim()
      .replaceAll(RegExp(r"({table_name})", caseSensitive: false), tableName)
      .trim());
}
