// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "emoji.dart";

class CaptchaResult extends JsonDart {
  CaptchaResult(super.rawData);

  static Map get defaultData {
    return {
      "@type": "captchaResult",
      "type": "words",
      "emoji_answer": {"@type": "emoji"},
      "random_words": [],
      "words": []
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get type {
    try {
      if (rawData["type"] is String == false) {
        return null;
      }
      return rawData["type"] as String;
    } catch (e) {
      return null;
    }
  }

  Emoji get emoji_answer {
    try {
      if (rawData["emoji_answer"] is Map == false) {
        return Emoji({});
      }
      return Emoji(rawData["emoji_answer"] as Map);
    } catch (e) {
      return Emoji({});
    }
  }

  List<Object> get random_words {
    try {
      if (rawData["random_words"] is List == false) {
        return [];
      }
      return (rawData["random_words"] as List).cast<Object>();
    } catch (e) {
      return [];
    }
  }

  List<Object> get words {
    try {
      if (rawData["words"] is List == false) {
        return [];
      }
      return (rawData["words"] as List).cast<Object>();
    } catch (e) {
      return [];
    }
  }

  static CaptchaResult create({
    String? special_type,
    String? type,
    Emoji? emoji_answer,
    List<Object>? random_words,
    List<Object>? words,
  }) {
    CaptchaResult captchaResult = CaptchaResult({
      "@type": special_type,
      "type": type,
      "emoji_answer": (emoji_answer != null) ? emoji_answer.toJson() : null,
      "random_words": random_words,
      "words": words,
    });

    return captchaResult;
  }
}
